  
        
;        GP1 MAIN AUSGANG 
;        GP2 INTERRUPT AUSGANG 
;   ZUSAMMEN GESCHALTET WIE BEI DTMF-GEBER 
        
;        GP5 TASTER --> ENABLE / AKTIV BEI LOW        

        
;*****************************************************************************
;*                            SIRENE MIT 2 FREQUENZEN  (GP1+GP2)             *
;*                              28.08.20                                     *
;*****************************************************************************

        LIST    P=12F629       
        TITLE   "LKW-SIRENE"

        ERRORLEVEL -302
        INCLUDE <P12F629.INC>

__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;4MHZ OSZILLATOR T=1:F / T=1:4MHZ / T=0,25SEC --> 1MAL NOP = 1,0SEC
        
;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


MERK                    EQU     0X22 
MERK1                   EQU     0X23               ;BEGINNT MIT HIGH HALBWELLE BEI GP2 ALS INTERRUPT
ZAE                     EQU     0X24               ;EINE HALBWELLE GP1(MAIN) 420HZ
                     
W_STACK                 EQU     0X25               ;FUER PUSH UND POP
S_STACK                 EQU     0X26               ;FUER PUSH UND POP


;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7



;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        MOVLW   B'11111001'                 ;GP1 + GP2 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL 

;INIT TIMER 0 
                MOVLW   B'10000100'             ;BIT0-2 1=PRESCALER1:32, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG  
                
;                        MOVLW   B'10000111'   ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, 
                                              ;BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
;                        MOVWF   OPTION_REG 
                                              
                        BANK0
 
;INIT TIMER 1 
                        MOVLW   B'00110000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [11]1:8 VORERST 0
                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
                        BSF     MERK1, BIT0 ;START BEI INTERRUPT MIT HIGH-HALBWELLE
                          
                        
                        
;INTERRUPT ZULASSEN             
                        BSF     INTCON, GIE     ;ALLGEMEINES INTERRUPT ENABLE
                        BSF     INTCON, PEIE 
                        BSF     INTCON, T0IE    ;OVERFLOW INTERRUPT BEI TIMER0 ZULASSEN/ENABLE
                         
                          
;TIMER0 START                        
;                        MOVLW D'70'
;                        MOVWF   TMR0            ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
;                        BCF     INTCON, T0IF    ;OVERFLOW
                     
ANFANG                        
        BSF     GPIO, GP1
        
        BTFSC   GPIO, GP5
        GOTO    ANF01
        
        CALL    ZS_TON        
        
        BCF     GPIO, GP1       ;DAMIT STROM RAUSKOMMT

        BTFSC   GPIO, GP5
        GOTO    ANF01
   
        CALL    ZS_TON
        GOTO    ANFANG

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,       
ANF01   BCF     GPIO, GP1       ;DAMIT KEIN STROM RAUSKOMMT

LL1     BCF     INTCON, GIE     ;INTERRUPT SPERREN 
        BTFSC   INTCON, GIE
        GOTO    LL1
        BCF     GPIO, GP2       ;DAMIT KEIN STROM RAUSKOMMT
        
ANF02   BTFSC   GPIO, GP5
        GOTO    ANF02
                                
;TIMER0 START                        
        MOVLW   D'191'
        MOVWF   TMR0            ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
        BCF     INTCON, T0IF    ;OVERFLOW
   
        BSF     INTCON, GIE     ;INTERRUPT WIEDER EINSCHALTEN
     
        GOTO    ANFANG
        
;*****************************************************************************
;*                            INTERRUPT-PROGRAMM TON AN GP2                  *
;*****************************************************************************
INTERRUPT
        PUSH
        
        BTFSS   MERK1, BIT0
        GOTO    INT2
        
        BSF     GPIO, GP2
        BCF     MERK1, BIT0
        GOTO    INT1
        
INT2
        BCF     GPIO, GP2
        BSF     MERK1, BIT0
INT1
;TIMER0 START                        
        MOVLW   D'191'
        MOVWF   TMR0            ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
        BCF     INTCON, T0IF    ;OVERFLOW
 
        POP
        RETFIE
        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;BERECHNUNG TIMER0 FUER 240HZ
;T=1:FREQUENZ /// T=1:240HZ=4,16666MSEC /FUER EINE HALBWELLE :2= 2,08333MSEC
                        
;ZEITBERECHNUNG FUER 2,083MSEC
;PRESCALER 32X  *  SYSTEM 4X  * TAKTZEIT ====> 32*4*0,25SEC=32SEC 
;2,083MSEC : 32SEC= 65,09  GENOMMEN GANZAHLIG 65                                      
;ALSO NACHRECHNUNG 
;
;TMR0 ALSO D'256'-D'65'=D'191' 
;191 DEZIMAL OBEN EINTRAGEN
                        
;BEI D'191' WAREN ES 238HZ GENOMMEN HOERT SICH GUT AN
;BEI D'190' WAREN ES 234HZ         
    
        
;*****************************************************************************
;*                            ZEITSCHLEIFE TON AN GP1                        *
;*****************************************************************************
ZS_TON
 
        MOVLW   D'104' ; FUER 240HZ EINE HALBWELLE
        MOVWF   ZAE
        
ZS_TON1
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP ;10STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        ;NOP
        ;NOP ;20STCK. NOPS

        DECFSZ  ZAE, F
        GOTO    ZS_TON1

        RETURN
        
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ZU FREQUENZ:
;BERECHNUNG:
;T=1:F  /  T=1:240HZ=4,16666MSEC /FUER EINE HALBWELLE :2= 2,08333MSEC

;ZEITSCHLEIFE MIT NOP'S 240HZ BERECHNEN:
;2,08333MSEC : 1,0SEC = 2083 (NOP'S) 
;2083 (NOP'S) : 20(NOP'S) = 104,15MAL(DURCHLAEUFE) GENOMMEN 104

;BEI 20X NOP  ==  200HZ
;1MAL NOP ENTSPRICHT 8HZ
 
;BEI 18X NOP  ==  225HZ  KLANG GUT
 


                        END
                        
                        
                        





